/*************************************
*      PathFinder version 1.0        *
*   http://www.andre-michelle.com    *
* thanks to Ralf Siegel & Ralf Bokel *
*************************************/

var Pathfinder = function ( map ) {

	this.map = map;

	// bokels ExtendedBroadcaster for the removeListener bug //

	ExtendedBroadcaster.initialize ( this );

}

var p = PathFinder.prototype;

p.findPath = function ( x0 , y0 , x1 , y1 ) {

	var map = this.map;
	var occ = [];
	var scope = this;
	var pathFound = false;

	var foundPath;

	var move = function () {

		var x = this.x;
		var y = this.y;
		var path = this.path;

		// remove agent on left map, crawled field, pathfound //
		if ( map[ y ][ x ] == undefined || occ[ y ][ x ] || pathFound ) {

			scope.removeListener ( this );

			return false;

		};

		// remove all agent if path is found //
		if ( x == x1 && y == y1 ) {

			pathFound = true;

			for ( var i in scope._listeners ) scope.removeListener ( scope._listeners[i] );

			foundPath = path.concat( [ { x: x , y: y } ] );
			return true;

		}

		// occupy crawled Fields //
		if ( occ[ y ] == undefined ) occ[ y ] = []; occ[ y ][ x ] = true;

		// scan for nodes and move Agent - if node > create Agent with historyPath //
		switch ( this.dir ) {

			case 1:

				if ( ~map[ y + 1 ][ x ] & 1 ) createAgent ( x , y + 1 , 4 , path.concat ( [ { x: x , y: y } ] ) );
				if ( ~map[ y - 1 ][ x ] & 1 ) createAgent ( x , y - 1 , 8 , path.concat ( [ { x: x , y: y } ] ) );

				if ( ~map[ y ][ x + 1 ] & 1 ) { this.x++; path.push ( { x: x , y: y } ); };

				return;

			case 2:

				if ( ~map[ y + 1 ][ x ] & 1 ) createAgent ( x , y + 1 , 4 , path.concat ( [ { x: x , y: y } ] ) );
				if ( ~map[ y - 1 ][ x ] & 1 ) createAgent ( x , y - 1 , 8 , path.concat ( [ { x: x , y: y } ] ) );

				if ( ~map[ y ][ x - 1 ] & 1 ) { this.x--; path.push ( { x: x , y: y } ); };

				return;

			case 4:

				if ( ~map[ y ][ x + 1 ] & 1 ) createAgent ( x + 1 , y , 1 , path.concat ( [ { x: x , y: y } ] ) );
				if ( ~map[ y ][ x - 1 ] & 1 ) createAgent ( x - 1 , y , 2 , path.concat ( [ { x: x , y: y } ] ) );

				if ( ~map[ y + 1 ][ x ] & 1 ) { this.y++; path.push ( { x: x , y: y } ); };

				return;

			case 8:

				if ( ~map[ y ][ x + 1 ] & 1 ) createAgent ( x + 1 , y , 1 , path.concat ( [ { x: x , y: y } ] ) );
				if ( ~map[ y ][ x - 1 ] & 1 ) createAgent ( x - 1 , y , 2 , path.concat ( [ { x: x , y: y } ] ) );

				if ( ~map[ y - 1 ][ x ] & 1 ) { this.y--; path.push ( { x: x , y: y } ); };

				return;

		}

	}

	var createAgent = function ( x , y , dir , path ) {

		if ( map[ y ][ x ] == undefined ) return;

		scope.addListener ( { x: x, y: y, dir: dir, move: move, path: path } );

	}

	// create Agents //

	if ( ~map[ y0 ][ x0 + 1 ] & 1 ) createAgent ( x0 + 1 , y0 , 1 , [ { x: x0 , y: y0 } ] );
	if ( ~map[ y0 ][ x0 - 1 ] & 1 ) createAgent ( x0 - 1 , y0 , 2 , [ { x: x0 , y: y0 } ] );
	if ( ~map[ y0 + 1 ][ x0 ] & 1 ) createAgent ( x0 , y0 + 1 , 4 , [ { x: x0 , y: y0 } ] );
	if ( ~map[ y0 - 1 ][ x0 ] & 1 ) createAgent ( x0 , y0 - 1 , 8 , [ { x: x0 , y: y0 } ] );

	while ( !pathFound ) this.broadcastMessage( "move" );

	return foundPath;

}



